//Use screenX and screenY for direct model painting
//Add check for .png files to MinecraftSkin class
//Add MinecraftSkin object parameter to MCPonyBase
//Detect Human skins wiht load/autoload by fixing MCPonyBase.revert

//Objects
  MinecraftSkin Minecraft = new MinecraftSkin();
  MCPonyBase PonyBase = new MCPonyBase(Minecraft);
  
  MCPonyNormal NormalPony = new MCPonyNormal(PonyBase);
  MCPonyFoal SmallPony = new MCPonyFoal(PonyBase);
  MCPonyLarge LargePony = new MCPonyLarge(PonyBase);
  MCPonyAlicorn PrincessPony = new MCPonyAlicorn(PonyBase);
  MCHuman Human = new MCHuman(Minecraft);
//Model direction variables
  int directionY = 60;
  int directionX = 210;

//Libraries
/*
http://www.lagers.org.uk/g4p/
http://www.lagers.org.uk/g4p/distribution/web/reference/guicomponents/GComponent.html
/*/
//GUI library
import guicomponents.*;
//OPENGL Can be removed if using P3D to save space Set to renderer to "P3D" or "OPENGL" accordingly

import processing.opengl.*;
String renderer = OPENGL;
//String renderer = P3D;

void setup(){
  size(800,600,renderer);
  GUIsetup(renderer);
}

void draw(){
  background(255, 255, 255);
  line(width/2, 0, width/2, height);
  line(0, height/2, width, height/2);
  //Draw preview
    //2D
//      noStroke();
//      for(int i=0; i<64; i++){
//        for(int j=0; j<32; j++){
//          fill(128, 128, 128);
//          rect(16*i+20, 16*j+height-276, 16, 16);
//          fill(red(Minecraft.loadedImage.pixels[i+j*64]),green(Minecraft.loadedImage.pixels[i+j*64]),blue(Minecraft.loadedImage.pixels[i+j*64]),alpha(Minecraft.loadedImage.pixels[i+j*64]));
//          rect(16*i+20, 16*j+height-276, 16, 16);
//        }
//      }
    //3D
    //Rotate with mouse movement
      if(leftDown){
        directionX = directionX + mouseDX();
        directionY = directionY + mouseDY();
      }
    //println(mouseX+","+mouseY);
    pushMatrix();
      //Auto load
        if(MenuItemCheck[0][4].isSelected()){
          //Revert image
            Minecraft.revert();
          //Update Pony
            PonyBase.update(Minecraft);
            PonyBase.specialScan(Minecraft);
          //Update Human
            Human.update(Minecraft);
          //Setup GUI
            MenuItemCheck[0][4].setSelected(true);
        }
        noSmooth();
      //Smoothing
        if(MenuItemCheck[4][1].isSelected()){
          smooth();
        }
        noLights();
      //Lighting
        if(MenuItemCheck[4][2].isSelected()){
          lights();
        }
      translate(width/2, height/2, 0);
      rotateX(radians(directionY));
      rotateZ(radians(directionX));
        noStroke();
        if(!MenuItemRadio[5][4].isSelected()){
          if(MenuItemRadio[7][0].isSelected()){
            translate(NormalPony.centerTranslate[MenuItemRadioGroups[1].selectedIndex()].x, NormalPony.centerTranslate[MenuItemRadioGroups[1].selectedIndex()].y, NormalPony.centerTranslate[MenuItemRadioGroups[1].selectedIndex()].z);
            NormalPony.drawPony();
          }
          if(MenuItemRadio[7][1].isSelected()){
            //translate(SmallPony.centerTranslate[MenuItemRadioGroups[1].selectedIndex()].x, SmallPony.centerTranslate[MenuItemRadioGroups[1].selectedIndex()].y, SmallPony.centerTranslate[MenuItemRadioGroups[1].selectedIndex()].z);
            SmallPony.drawPony();
          }
          if(MenuItemRadio[7][2].isSelected()){
            //translate(LargePony.centerTranslate[MenuItemRadioGroups[1].selectedIndex()].x, LargePony.centerTranslate[MenuItemRadioGroups[1].selectedIndex()].y, LargePony.centerTranslate[MenuItemRadioGroups[1].selectedIndex()].z);
            LargePony.drawPony();
          }
          if(MenuItemRadio[7][3].isSelected()){
            //translate(PrincessPony.centerTranslate[MenuItemRadioGroups[1].selectedIndex()].x, PrincessPony.centerTranslate[MenuItemRadioGroups[1].selectedIndex()].y, PrincessPony.centerTranslate[MenuItemRadioGroups[1].selectedIndex()].z);
            PrincessPony.drawPony();
          }
        }
        else{
          translate(Human.centerTranslate[MenuItemRadioGroups[1].selectedIndex()].x, Human.centerTranslate[MenuItemRadioGroups[1].selectedIndex()].y, Human.centerTranslate[MenuItemRadioGroups[1].selectedIndex()].z);
          Human.drawHuman();
        }
    popMatrix();
    smooth();
    noLights();
    strokeWeight(1);
  GUIloop(renderer);
}
