class MCHuman{
  MinecraftSkin Minecraft;
  //GUI Elements
    //Menu Bar
      String[] MenuBar = {"File","Hide/Show","Grid","Pose","Special","Kind"};
      GButton[] Menus = new GButton[MenuBar.length];
    //Names
    //First character is for type of component
    // ! Button
    // @ Radio Button
    // # Checkbox
      final String[][] GUIMenuItemNames = { {"!Open","!Save","!Save as","!Load","#Auto-Load"},
                                            {"#Head","#Body","#Left Leg","#Right Leg","#Left Arm","#Right arm","#Hair"},
                                            {"#Head","#Body","#Left Leg","#Right Leg","#Left Arm","#Right arm","#Hair"},
                                            {"@Normal","@Sleeping","@Sneaking"},
                                            {"#Grid","#Smoothing","#Lights","!Fix Alpha","!Fix Black"},
                                            {"@Earth Pony","@Pegasus","@Unicorn","@Alicorn","@Human"},
                                          };
    //Buttons
      final GButton[][] GUIButtons = { new GButton[GUIMenuItemNames[0].length],
                                       new GButton[GUIMenuItemNames[1].length],
                                       new GButton[GUIMenuItemNames[2].length],
                                       new GButton[GUIMenuItemNames[3].length],
                                       new GButton[GUIMenuItemNames[4].length],
                                       new GButton[GUIMenuItemNames[5].length]
                                     };
                                    
    //Checkboxes
      final GCheckbox[][] GUIChecks = { new GCheckbox[GUIMenuItemNames[0].length],
                                        new GCheckbox[GUIMenuItemNames[1].length],
                                        new GCheckbox[GUIMenuItemNames[2].length],
                                        new GCheckbox[GUIMenuItemNames[3].length],
                                        new GCheckbox[GUIMenuItemNames[4].length],
                                        new GCheckbox[GUIMenuItemNames[5].length]
                                      };
    //Radio Buttons
      final GOptionGroup[] GUIRadioGroups = new GOptionGroup[GUIMenuItemNames.length];
      final GOption[][] GUIRadios = { new GOption[GUIMenuItemNames[0].length],
                                      new GOption[GUIMenuItemNames[1].length],
                                      new GOption[GUIMenuItemNames[2].length],
                                      new GOption[GUIMenuItemNames[3].length],
                                      new GOption[GUIMenuItemNames[4].length],
                                      new GOption[GUIMenuItemNames[5].length]
                                    };
    //Viewing Options
      int pose;
      boolean[] show = {true,true,true,true,true,true,true};
      boolean grid = false;
  MCHuman(MinecraftSkin Skin){
    Minecraft = Skin;
  }
  
  void drawHuman(){
    humanBody();
    humanHead();
    humanHair();
    humanLeftLeg();
    humanRightLeg();
    humanLeftArm();
    humanRightArm();
  }
  
  void humanBody(){
    //Top of Human Body
      Minecraft.PlayerSkin.xyPlane(28, 12, 48, 20, 16, 28, 20, 8);
    //Bottom of Human Body
      Minecraft.PlayerSkin.xyPlane(28, 12, -48, 28, 16, 36, 20, 8);
    //Front of Human Body
      Minecraft.PlayerSkin.xzPlane(28, -16, 44, 20, 20, 28, 32, 8);
    //Back of Human Body
      Minecraft.PlayerSkin.XzPlane(-28, 16, 44, 32, 20, 40, 32, 8);
    //Right side of Human Body (Player Perspective)
      Minecraft.PlayerSkin.yzPlane(32, 12, 44, 16, 20, 20, 32, 8);
    //Left side of Human Body (Player Perspective)
      Minecraft.PlayerSkin.YzPlane(-32, -12, 44, 28, 20, 32, 32, 8);
  }
  
  void humanHead(){
    //Top of head
      Minecraft.PlayerSkin.xyPlane(28, 28, 112, 8, 0, 16, 8, 8);
    //Bottom of head
      Minecraft.PlayerSkin.xYPlane(28, -28, 48, 16, 0, 24, 8, 8);
    //Left of head
      Minecraft.PlayerSkin.YzPlane(-32, -28, 108, 16, 8, 24, 16, 8);
    //Right of head
      Minecraft.PlayerSkin.yzPlane(32, 28, 108, 0, 8, 8, 16, 8);
    //Front of head
      Minecraft.PlayerSkin.xzPlane(28, -32, 108, 8, 8, 16, 16, 8);
    //Back of head
      Minecraft.PlayerSkin.xzPlane(28, 32, 108, 24, 8, 32, 16, 8);
  }
  
  void humanHair(){
    //Top of hair
      Minecraft.PlayerSkin.xyPlane(32, 32, 116, 40, 0, 48, 8, 9);
    //Bottom of hair
      Minecraft.PlayerSkin.xyPlane(32, 32, 44, 48, 0, 56, 8, 9);
    //Left of hair (Player Perspective)
      Minecraft.PlayerSkin.YzPlane(-36, -32, 111, 48, 8, 56, 16, 9);
    //Right of hair (Player Perspective)
      Minecraft.PlayerSkin.yzPlane(36, 32, 111, 32, 8, 40, 16, 9);
    //Front of hair
      Minecraft.PlayerSkin.xzPlane(32, -36, 111, 40, 8, 48, 16, 9);
    //Back of hair
      Minecraft.PlayerSkin.XzPlane(-32, 36, 111, 56, 8, 64, 16, 9);
  }
  
  void humanLeftArm(){
    //Top of arm
      Minecraft.PlayerSkin.XyPlane(-60, 12, 48, 44, 16, 48, 20, 8);
    //Bottom of arm
      Minecraft.PlayerSkin.xyPlane(-36, 12, -48, 48, 16, 52, 20, 8);
    //Front of arm
      Minecraft.PlayerSkin.XzPlane(-60, -16, 44, 44, 20, 48, 32, 8);    
    //Back of arm
      Minecraft.PlayerSkin.xzPlane(-36, 16, 44, 52, 20, 56, 32, 8);
    //Left of arm (Outside)
      Minecraft.PlayerSkin.yzPlane(-64, 12, 44, 40, 20, 44, 32, 8);
    //Right of arm (Inside)
      Minecraft.PlayerSkin.YzPlane(-32, -12, 44, 48, 20, 52, 32, 8);
  }
  
  void humanRightArm(){
    //Top of arm
      Minecraft.PlayerSkin.xyPlane(60, 12, 48, 44, 16, 48, 20, 8);
    //Bottom of arm
      Minecraft.PlayerSkin.xYPlane(60, -12, -48, 48, 16, 52, 20, 8);
    //Front of arm
      Minecraft.PlayerSkin.xzPlane(60, -16, 44, 44, 20, 48, 32, 8);
    //Back of arm
      Minecraft.PlayerSkin.XzPlane(36, 16, 44, 52, 20, 56, 32, 8);
    //Right of arm (Outside)
      Minecraft.PlayerSkin.yzPlane(64, 12, 44, 40, 20, 44, 32, 8);
    //Left of arm (Inside)
      Minecraft.PlayerSkin.YzPlane(32, -12, 44, 48, 20, 52, 32, 8);
  }
  
  void humanLeftLeg(){
    //Top of leg
      Minecraft.PlayerSkin.XyPlane(-28, 12, -48, 4, 16, 8, 20, 8);
    //Bottom of leg
      Minecraft.PlayerSkin.XYPlane(-28, -12, -144, 8, 16, 12, 20, 8);
    //Front of leg
      Minecraft.PlayerSkin.XzPlane(-28, -16, -52, 4, 20, 8, 32, 8);
    //Back of leg
      Minecraft.PlayerSkin.xzPlane(-4, 16, -52, 12, 20, 16, 32, 8);
    //Left of leg (Outside)
      Minecraft.PlayerSkin.yzPlane(-32, 12, -52, 0, 20, 4, 32, 8);
    //Right of leg (Inside)
      Minecraft.PlayerSkin.YzPlane(0, -12, -52, 8, 20, 12, 32, 8);
  }
  
  void humanRightLeg(){
    //Top of leg
      Minecraft.PlayerSkin.xyPlane(28, 12, -48, 4, 16, 8, 20, 8);
    //Bottom of leg
      Minecraft.PlayerSkin.xYPlane(28, -12, -144, 8, 16, 12, 20, 8);
    //Front of leg
      Minecraft.PlayerSkin.xzPlane(28, -16, -52, 4, 20, 8, 32, 8);
    //Back of leg
      Minecraft.PlayerSkin.XzPlane(4, 16, -52, 12, 20, 16, 32, 8);
    //Right of leg (Outside)
      Minecraft.PlayerSkin.yzPlane(32, 12, -52, 0, 20, 4, 32, 8);
    //Left of leg (Inside)
      Minecraft.PlayerSkin.YzPlane(0, -12, -52, 8, 20, 12, 32, 8);
  }
  
  void outline(){
      stroke(0);
      noFill();
      strokeWeight(2);
    //draw outline of body
      box(64, 32, 96);
    //draw outline of head
      pushMatrix();
      translate(0, 0, 80);
      box(64, 64, 64);
      popMatrix();
    //draw outline of hair
      pushMatrix();
      translate(0, 0, 80);
      box(72, 72, 72);
      popMatrix();
    //draw outline of left leg
      pushMatrix();
      translate(-16, 0, -96);
      box(32, 32, 96);
      popMatrix();
    //draw outline of right leg
      pushMatrix();
      translate(16, 0, -96);
      box(32, 32, 96);
      popMatrix();
    //draw outline of left arm
      pushMatrix();
      translate(-48, 0, 0);
      box(32, 32, 96);
      popMatrix();
    //draw outline of right arm
      pushMatrix();
      translate(48, 0, 0);
      box(32, 32, 96);
      popMatrix();
  }
}
