class MCPonyFoal{
  //Normal Pony Model
  MinecraftSkin Minecraft;
  MCPonyBase PonyBase;
    
  MCPonyFoal(MinecraftSkin Skin, MCPonyBase Base){
    Minecraft = Skin;
    PonyBase = Base;
    PonyBase.specialScan(Minecraft);
  }
  
  void drawPony() {
    if(PonyBase.grid){
      strokeWeight(2);
      stroke(0, 0, 0, 255);
    }
      pushMatrix();
      scale(0.9);
      translate(0,28,-28);
    //Head
      if(PonyBase.show[0] == true){
        head();
      }
    //Mane
      if(PonyBase.show[9] == true){
        mane();
      }
    //Ears
      if(PonyBase.show[1] == true){
        earLA();
        earRA();
      }
    //Snuzzle
      if(PonyBase.show[2] == true){
        if (PonyBase.male == 1) {
          snuzzleM();
        }
        else {
          snuzzleF();
        }
      }
      popMatrix();
      pushMatrix();
      scale(0.75);
      translate(0,8,-16);
    //Neck
      if(PonyBase.show[3] == true){
        neck();
      }
      popMatrix();
      pushMatrix();
      scale(0.625);
    //Body
      if(PonyBase.show[4] == true){
        bodyA();
      }
    //Tail 1
      if(PonyBase.show[7] == true){
        tailAS();
      }
    //Tail 2
      if(PonyBase.show[8] == true){
        tailAL();
      }
      scale(1, 1, 0.75);
      translate(0, 0, -10);
    //Left Legs
      if(PonyBase.show[5] == true){
        legFL();
        legHLA();
      }
    //Right Legs
      if(PonyBase.show[6] == true){
        legFR();
        legHRA();
      }
      popMatrix();
    //Magic
      switch(PonyBase.race) {
        case 1:
          //Earth Pony
          break;
        case 2:
          //Pegasus
            //Left Wing
            pushMatrix();
            scale(0.625);
              if(PonyBase.show[10] == true){
                LWing();
              }
            //Right Wing
              if(PonyBase.show[11] == true){
                RWing();
              }
            popMatrix();
          break;
        case 3:
          //Unicorn
            //Horn
              if(PonyBase.show[12] == true){
                hornA();
              }
            break;
        case 4:
          //Alicorn
              pushMatrix();
              scale(0.625);
            //Left Wing
              if(PonyBase.show[10] == true){
                LWing();
              }
            //Right Wing
              if(PonyBase.show[11] == true){
                RWing();
              }
              popMatrix();
              pushMatrix();
              translate(0,36,-38);
            //Horn
              if(PonyBase.show[12] == true){
                hornA();
              }
              popMatrix();
            break;
        default:
          break;
      }
  }
  
  void tailAL() {
    if (PonyBase.tailLength > 0) {
      pushMatrix();
      //Top of Tail
      Minecraft.PlayerSkin.xyPlane(12, 108, 48, 32, 0, 36, 4, 8);
      translate(0, 108, 44);
      //Tail Loop
      for (int i=0; i<PonyBase.tailLength; i++) {
        if (i%2 == 0) {
          tailSegment1();
        }
        else {
          tailSegment2();
        }
        translate(0, 0, -32);
      }
      //Bottom of Tail
      Minecraft.PlayerSkin.xyPlane(12, 0, 4, 32, 0, 36, 4, 8);
      popMatrix();
    }
  }
  
  void earRA() {
    pushMatrix();
    translate(0, -8, 16);
    //Top of ear
    Minecraft.PlayerSkin.xyPlane(28, -44, 112, 14, 16, 16, 18, 8);
    //Bottom of ear
    //???
    //Left of ear (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -52, 108, 16, 18, 18, 20, 8);
    //Right of ear (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(32, -44, 108, 12, 18, 14, 20, 8);
    //Front of ear
    Minecraft.PlayerSkin.xzPlane(28, -56, 108, 14, 18, 16, 20, 8);
    //Back of ear
    Minecraft.PlayerSkin.XzPlane(20, -40, 108, 18, 18, 20, 20, 8);
    popMatrix();
  }
  
  void earLA() {
    pushMatrix();
    translate(0, -8, 16);
    //Top of ear
    Minecraft.PlayerSkin.XyPlane(-28, -44, 112, 14, 16, 16, 18, 8);
    //Bottom of ear
    //???
    //Left of ear (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -52, 108, 16, 18, 18, 20, 8);
    //Right of ear (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(-32, -44, 108, 12, 18, 14, 20, 8);
    //Front of ear
    Minecraft.PlayerSkin.XzPlane(-28, -56, 108, 14, 18, 16, 20, 8);
    //Back of ear
    Minecraft.PlayerSkin.xzPlane(-20, -40, 108, 18, 18, 20, 20, 8);
    popMatrix();
  }
  
  void tailAS() {
    pushMatrix();
    translate(0, 70, 24);
    rotateX(-1*PI/3);
    translate(0, 0, -20);
//    //Old Left of Tail (Pony Perspective)
//    Minecraft.PlayerSkin.yZPlane(8, 4, 0, 32, 0, 34, 6, 8);
//    //Old Right of Tail (Pony Perspective)
//    Minecraft.PlayerSkin.yZPlane(-8, 4, 0, 32, 0, 34, 6, 8);
    //Left of Tail (Pony Perspective)
    Minecraft.PlayerSkin.ZYPlane(8, -4, 0, 32, 0, 38, 2, 8);
    //Right of Tail (Pony Perspective)
    Minecraft.PlayerSkin.ZYPlane(-8, -4, 0, 32, 0, 38, 2, 8);
//    //Old Top of Tail
//    Minecraft.PlayerSkin.xZPlane(4, -8, 0, 32, 0, 34, 6, 8);
    // Top of Tail
    Minecraft.PlayerSkin.xzPlane(4, -8, 40, 32, 0, 34, 6, 8);
    //Bottom of Tail
    Minecraft.PlayerSkin.xZPlane(4, 8, 0, 32, 0, 34, 6, 8);
    //Front of tail (Hidden)
    //(???)
//    //Old Back of Tail (End)
//    Minecraft.PlayerSkin.xyPlane(4, 4, 44, 32, 0, 34, 2, 8);
    //Back of Tail (End)
    Minecraft.PlayerSkin.xYPlane(4, -4, 44, 32, 0, 34, 2, 8);
    popMatrix();
  }
  
  void tailSegment1() {
    //Left of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -24, 0, 36, 0, 40, 4, 8);
    //Right of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -24, 0, 36, 0, 40, 4, 8);
    //Back of Tail
    Minecraft.PlayerSkin.xzPlane(12, 4, 0, 32, 0, 36, 4, 8);
    //Front of Tail
    Minecraft.PlayerSkin.xzPlane(12, -28, 0, 32, 0, 36, 4, 8);
  }
  
  void tailSegment2() {
    //Left of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -24, 0, 36, 4, 40, 8, 8);
    //Right of Tail (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -24, 0, 36, 4, 40, 8, 8);
    //Back of Tail
    Minecraft.PlayerSkin.xzPlane(12, 4, 0, 32, 4, 36, 8, 8);
    //Front of Tail
    Minecraft.PlayerSkin.xzPlane(12, -28, 0, 32, 4, 36, 8, 8);
  }
  
  void snuzzleM() {
    pushMatrix();
    translate(0, -8, 16);
    //Top of snuzzle
    Minecraft.PlayerSkin.xyPlane(12, -100, 56, 10, 13, 14, 14, 8);
    //Bottom of snuzzle
    Minecraft.PlayerSkin.xyPlane(12, -100, 32, 10, 15, 14, 16, 8);
    //Right of snuzzle (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(16, -100, 52, 10, 13, 11, 16, 8);
    //Left of snuzzle (Pony Perspective)
    Minecraft.PlayerSkin.yzPlane(-16, -100, 52, 13, 13, 14, 16, 8);
    //Front of snuzzle
    Minecraft.PlayerSkin.xzPlane(12, -104, 52, 10, 13, 14, 16, 8);
    popMatrix();
  }
  
  void snuzzleF() {
    pushMatrix();
    translate(0, -8, 16);
    //Right of snuzzle (Pony Perspective)
    //Top
    Minecraft.PlayerSkin.yzPlane(8, -100, 52, 11, 12, 12, 13, 8);
    //Bottom
    Minecraft.PlayerSkin.yzPlane(16, -100, 44, 9, 14, 10, 16, 8);
    //Left of snuzzle (Pony Perspective)
    //Top
    Minecraft.PlayerSkin.yzPlane(-8, -100, 52, 12, 12, 13, 13, 8);
    //Bottom
    Minecraft.PlayerSkin.yzPlane(-16, -100, 44, 14, 14, 15, 16, 8);
    //Top of snuzzle
    //Right (Pony Perspective)
    Minecraft.PlayerSkin.xyPlane(12, -100, 48, 9, 14, 10, 15, 8);
    //Middle
    Minecraft.PlayerSkin.xyPlane(4, -100, 56, 11, 12, 13, 13, 8);
    //Left (Pony Perspective)
    Minecraft.PlayerSkin.xyPlane(-12, -100, 48, 14, 14, 15, 15, 8);
    //Bottom of snuzzle
    Minecraft.PlayerSkin.xyPlane(12, -100, 32, 10, 15, 14, 16, 8);
    //Front of snuzzle
    //Top
    Minecraft.PlayerSkin.xzPlane(4, -104, 52, 11, 13, 13, 14, 8);
    //Bottom
    Minecraft.PlayerSkin.xzPlane(12, -104, 44, 10, 14, 14, 16, 8);
    popMatrix();
  }
  
  void neck() {
    pushMatrix();
    translate(0, -60, 56);
    rotateX(PI/12);
    //Left of neck (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(-16, -8, -6, 0, 16, 4, 20, 8);
    //Rignt of neck (Pony Perspective)
    Minecraft.PlayerSkin.YzPlane(16, -8, -6, 0, 16, 4, 20, 8);
    //Front of neck
    Minecraft.PlayerSkin.xzPlane(12, 20, -6, 0, 16, 4, 20, 8);
    //Back of neck
    Minecraft.PlayerSkin.xzPlane(12, -12, -6, 0, 16, 4, 20, 8);
    popMatrix();
  }
  
  void legHLA() {
    //Top of leg
    Minecraft.PlayerSkin.XyPlane(-28, 44, -32, 4, 16, 8, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.XyPlane(-28, 44, -128, 8, 16, 12, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.XzPlane(-28, 16, -36, 4, 20, 8, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.xzPlane(-4, 48, -36, 12, 20, 16, 32, 8);
    //Left of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(-32, 44, -36, 0, 20, 4, 32, 8);
    //Right of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 8, 20, 12, 32, 8);
  }
  
  void legHRA() {
    //Top of leg
    Minecraft.PlayerSkin.xyPlane(28, 44, -32, 4, 16, 8, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.xyPlane(28, 44, -128, 8, 16, 12, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.xzPlane(28, 16, -36, 4, 20, 8, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.XzPlane(4, 48, -36, 12, 20, 16, 32, 8);
    //Right of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(32, 44, -36, 0, 20, 4, 32, 8);
    //Left of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 8, 20, 12, 32, 8);
  }
  
  void bodyA() {
    //Front of Pony (Chest)
      Minecraft.PlayerSkin.xzPlane(28, -64, 28, 20, 20, 28, 28, 8);
    //Back of pony (Flank)
      //Top
        Minecraft.PlayerSkin.xzPlane(28, 64, 28, 36, 16, 44, 20, 8);
      //Bottom
        Minecraft.PlayerSkin.xzPlane(28, 64, -4, 36, 16, 44, 20, 8);
    //Top of Body
      //Front (Withers)
      Minecraft.PlayerSkin.xyPlane(28, -36, 32, 20, 16, 28, 20, 8);
      //Back
      Minecraft.PlayerSkin.XYPlane(-28, -28, 32, 32, 20, 40, 32, 8);
    //Bottom of body
      //Front
        Minecraft.PlayerSkin.xyPlane(28, -36, -32, 28, 16, 36, 20, 8);
      //Middle (Barrel)
        Minecraft.PlayerSkin.xYPlane(28, -28, -32, 56, 0, 64, 8, 8);
      //Back
        Minecraft.PlayerSkin.xYPlane(28, 36, -32, 36, 16, 44, 20, 8);
    //Left side of Pony (Pony Perspective)
      //Left Shoulder
        Minecraft.PlayerSkin.YzPlane(-32, -60, 28, 28, 20, 32, 28, 8);
      //Middle
        Minecraft.PlayerSkin.YzPlane(-32, -28, 28, 24, 0, 32, 8, 8);
      //Back (Cutie Mark)
        Minecraft.PlayerSkin.YzPlane(-32, 36, 28, 4, 0, 8, 8, 8);
    //Right side of Pony (Pony Perspective)
      //Shoulder
        Minecraft.PlayerSkin.yzPlane(32, -36, 28, 16, 20, 20, 28, 8);
      //Middle
        Minecraft.PlayerSkin.YzPlane(32, -28, 28, 24, 0, 32, 8, 8);
      //Back (Right Cutie Mark)
        Minecraft.PlayerSkin.YzPlane(32, 36, 28, 4, 0, 8, 8, 8);
  }
  
  void hornA() {
    pushMatrix();
    translate(0, -108, 120);
    rotateX(PI/6);
    //Tip of horn
    Minecraft.PlayerSkin.xyPlane(0, 0, 20, 1, 3, 2, 4, 8);
    //Front of horn
    Minecraft.PlayerSkin.xzPlane(0, -4, 16, 1, 4, 2, 8, 8);
    //Back of horn
    Minecraft.PlayerSkin.xzPlane(0, 4, 16, 3, 4, 4, 8, 8);
    //Left of Horn
    Minecraft.PlayerSkin.yzPlane(-4, 0, 16, 2, 4, 3, 8, 8);
    //Right of Horn
    Minecraft.PlayerSkin.yzPlane(4, 0, 16, 0, 4, 1, 8, 8);
    popMatrix();
  }
  
  void LWing() {
    //Top of wing
    //Front
    Minecraft.PlayerSkin.xYPlane(-36, -28, 24, 62, 18, 64, 24, 8);
    //Back
    Minecraft.PlayerSkin.xYPlane(-36, 20, 8, 62, 24, 64, 26, 8);
    //Bottom of wing
    //Front
    Minecraft.PlayerSkin.XYPlane(-44, -28, -24, 58, 18, 60, 24, 8);
    //Back
    Minecraft.PlayerSkin.XYPlane(-44, 20, -8, 58, 24, 60, 26, 8);
    //Front of Wing
    //Top
    Minecraft.PlayerSkin.XzPlane(-44, -32, 20, 58, 16, 60, 18, 8);
    //Middle
    Minecraft.PlayerSkin.XzPlane(-44, -32, 4, 58, 16, 60, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.XzPlane(-44, -32, -12, 58, 16, 60, 18, 8);
    //Back of Wing
    //Top
    Minecraft.PlayerSkin.XzPlane(-44, 16, 20, 60, 16, 62, 18, 8);
    //Middle
    Minecraft.PlayerSkin.XzPlane(-44, 32, 4, 60, 16, 62, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.XzPlane(-44, 16, -12, 60, 16, 62, 18, 8);
    //Outside of Wing
    //Top
    Minecraft.PlayerSkin.zYPlane(-48, -28, 20, 56, 18, 58, 24, 8);
    //Middle
    Minecraft.PlayerSkin.zYPlane(-48, -28, 4, 56, 18, 58, 26, 8);
    //Bottom
    Minecraft.PlayerSkin.zYPlane(-48, -28, -12, 56, 18, 58, 24, 8);
  }
  
  void RWing() {
    //Top of wing
    //Front
    Minecraft.PlayerSkin.XYPlane(36, -28, 24, 62, 18, 64, 24, 8);
    //Back
    Minecraft.PlayerSkin.XYPlane(36, 20, 8, 62, 24, 64, 26, 8);
    //Bottom of wing
    //Front
    Minecraft.PlayerSkin.xYPlane(44, -28, -24, 58, 18, 60, 24, 8);
    //Back
    Minecraft.PlayerSkin.xYPlane(44, 20, -8, 58, 24, 60, 26, 8);
    //Front of Wing
    //Top
    Minecraft.PlayerSkin.xzPlane(44, -32, 20, 58, 16, 60, 18, 8);
    //Middle
    Minecraft.PlayerSkin.xzPlane(44, -32, 4, 58, 16, 60, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.xzPlane(44, -32, -12, 58, 16, 60, 18, 8);
    //Back of Wing
    //Top
    Minecraft.PlayerSkin.xzPlane(44, 16, 20, 60, 16, 62, 18, 8);
    //Middle
    Minecraft.PlayerSkin.xzPlane(44, 32, 4, 60, 16, 62, 18, 8);
    //Bottom
    Minecraft.PlayerSkin.xzPlane(44, 16, -12, 60, 16, 62, 18, 8);
    //Outside of Wing
    //Top
    Minecraft.PlayerSkin.zYPlane(48, -28, 20, 56, 18, 58, 24, 8);
    //Middle
    Minecraft.PlayerSkin.zYPlane(48, -28, 4, 56, 18, 58, 26, 8);
    //Bottom
    Minecraft.PlayerSkin.zYPlane(48, -28, -12, 56, 18, 58, 24, 8);
  }
  
  void legFL() {
    //Top of leg
    Minecraft.PlayerSkin.XyPlane(-28, -28, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.XyPlane(-28, -28, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.XzPlane(-28, -56, -36, 44, 20, 48, 32, 8);  
    //Back of leg
    Minecraft.PlayerSkin.xzPlane(-4, -24, -36, 52, 20, 56, 32, 8);
    //Left of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(-32, -28, -36, 40, 20, 44, 32, 8);
    //Right of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, -52, -36, 48, 20, 52, 32, 8);
  }
  
  void legHL() {
    //Top of leg
    Minecraft.PlayerSkin.XyPlane(-28, 44, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.XyPlane(-28, 44, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.XzPlane(-28, 16, -36, 44, 20, 48, 32, 8);  
    //Back of leg
    Minecraft.PlayerSkin.xzPlane(-4, 48, -36, 52, 20, 56, 32, 8);
    //Left of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(-32, 44, -36, 40, 20, 44, 32, 8);
    //Right of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 48, 20, 52, 32, 8);
  }
  
  void legFR() {
    //Top of leg
    Minecraft.PlayerSkin.xyPlane(28, -28, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.xyPlane(28, -28, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.xzPlane(28, -56, -36, 44, 20, 48, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.XzPlane(4, -24, -36, 52, 20, 56, 32, 8);
    //Right of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(32, -28, -36, 40, 20, 44, 32, 8);
    //Left of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, -52, -36, 48, 20, 52, 32, 8);
  }
  
  void legHR() {
    //Top of leg
    Minecraft.PlayerSkin.xyPlane(28, 44, -32, 44, 16, 48, 20, 8);
    //Bottom of leg (Hoof)
    Minecraft.PlayerSkin.xyPlane(28, 44, -128, 48, 16, 52, 20, 8);
    //Front of leg
    Minecraft.PlayerSkin.xzPlane(28, 16, -36, 44, 20, 48, 32, 8);
    //Back of leg
    Minecraft.PlayerSkin.XzPlane(4, 48, -36, 52, 20, 56, 32, 8);
    //Right of leg (Outside)
    Minecraft.PlayerSkin.yzPlane(32, 44, -36, 40, 20, 44, 32, 8);
    //Left of leg (Inside)
    Minecraft.PlayerSkin.YzPlane(0, 20, -36, 48, 20, 52, 32, 8);
  }
  
  void mane() {
    pushMatrix();
      translate(0, -8, 16);
      //Top of mane
      Minecraft.PlayerSkin.xyPlane(32, -33, 100, 40, 0, 48, 8, 9);
      //Bottom of mane
      Minecraft.PlayerSkin.xyPlane(32, -33, 29, 48, 0, 56, 8, 9);
      //Left of mane (Pony Perspective)
      Minecraft.PlayerSkin.YzPlane(-35, -96, 96, 48, 8, 56, 16, 9);
      //Right of mane (Pony Perspective)
      Minecraft.PlayerSkin.yzPlane(35, -33, 96, 32, 8, 40, 16, 9);
      //Front of mane
      Minecraft.PlayerSkin.xzPlane(32, -100, 96, 40, 8, 48, 16, 9);
      //Back of mane
      Minecraft.PlayerSkin.XzPlane(-31, -29, 96, 56, 8, 64, 16, 9);
    popMatrix();
  }
  
  void head() {
    pushMatrix();
      translate(0, -8, 16);
      //Top of head
      Minecraft.PlayerSkin.xyPlane(28, -36, 96, 8, 0, 16, 8, 8);
      //Bottom of head
      Minecraft.PlayerSkin.xYPlane(28, -92, 32, 16, 0, 24, 8, 8);
      //Left of head
      Minecraft.PlayerSkin.YzPlane(-32, -92, 92, 16, 8, 24, 16, 8);
      //Right of head
      Minecraft.PlayerSkin.yzPlane(32, -36, 92, 0, 8, 8, 16, 8);
      //Front of head
      Minecraft.PlayerSkin.xzPlane(28, -96, 92, 8, 8, 16, 16, 8);
      //Back of head
      Minecraft.PlayerSkin.XzPlane(-28, -32, 92, 24, 8, 32, 16, 8);
    popMatrix();
  }
}
