class GUI {
  GUI(){
    
  }
}
//Ideas
/*
2 Dimensional boolean array to indicate if menu items are disabled
*/

//Menu Bar
  String[] MenusNames;
  GButton[] Menus;
  
  int[] MenusWidths;
  
//Menu Items
  //int for index of opened menu.  -1 if all are closed
    int openedMenu = -1;
  //Menu Item Names
    String[][] MenuItemName;
  //Buttons
    GButton[][] MenuItemButtons;
  //Radio Buttons
    GOptionGroup[] MenuItemRadioGroups;
    GOption[][] MenuItemRadio;
  //Checkboxes
    GCheckbox[][] MenuItemCheck;

void GUIsetup(String renderer){
  //P3D Only
    if(renderer == P3D){
      //SEt textmode to SCREEN
      G4P.setTextMode(SCREEN);
      textMode(SCREEN);
    }
  //OPENGL Only
    else{
      
    }
  //Both
    //Look and Feel
      G4P.setColorScheme(this, GCScheme.GREY_SCHEME);
      G4P.setFont(this, "Monaco", 12);
      //Menu Bar
        MenusNames = PonyBase.MenuBar;
        Menus = PonyBase.Menus;
      //Menu Item Names
        MenuItemName = PonyBase.GUIMenuItemNames;
      //Buttons
        MenuItemButtons = PonyBase.GUIButtons;
      //Radio Buttons
        MenuItemRadioGroups = PonyBase.GUIRadioGroups;
        MenuItemRadio = PonyBase.GUIRadios;
      //Checkboxes
        MenuItemCheck = PonyBase.GUIChecks;
        
    //Component Creation
      //X offset for Menu Bar
        int xTemp = 1;
      //X offset for menu Items
        int xTempItem = 1;
        MenusWidths = new int[MenusNames.length];
        for(int i=0; i<Menus.length; i++){
          //Menu Bar
          //tagNo is the index -1 to prevent interference with Menu Items
          //First menu tagNo is -1
            MenusWidths[i] = MenusNames[i].length() * 7 + 12;
            Menus[i] = new GButton(this, MenusNames[i], xTemp, 1, MenusWidths[i], 20);
            Menus[i].tagNo = i * -1 -1;
            Menus[i].setTextAlign(GAlign.LEFT | GAlign.TOP);
          //X offset for menu items 
            xTemp = xTemp + MenusWidths[i] + 1;
        }
      //Menu Items
        for(int i=0; i<Menus.length; i++){
          //Component Creation
            //Option Groups
              MenuItemRadioGroups[i] = new GOptionGroup(this);
            //Menu Items
              //Y offset for Menu Items
                int yTempItem = 22;
                for(int j=0; j<MenuItemName[i].length; j++){
                  String MenuItemNameTemp = MenuItemName[i][j].substring(1);
                  //Component tagNo X = floor(button.tagNo / MenusNames.length)
                  //Component tagNo Y = button.tagNo % MenusNames.length
                  //First element of first menu is 0,0
                    //Button
                      if(MenuItemName[i][j].charAt(0) == '!'){
                        //Create button
                          MenuItemButtons[i][j] = new GButton(this, MenuItemNameTemp, xTempItem, yTempItem, 127, 20);
                          MenuItemButtons[i][j].tag = MenuItemNameTemp;
                          MenuItemButtons[i][j].tagNo = i * MenusNames.length + j;
                          MenuItemButtons[i][j].setTextAlign(GAlign.LEFT | GAlign.TOP);
                        //Disable button
                          MenuItemButtons[i][j].setVisible(false);
                          MenuItemButtons[i][j].setEnabled(false);
                      }
                    //Radio Button
                      if(MenuItemName[i][j].charAt(0) == '@'){
                        //Create radio button
                          MenuItemRadio[i][j] = new GOption(this, MenuItemNameTemp, xTempItem, yTempItem, 127);
                          MenuItemRadio[i][j].tag = MenuItemNameTemp;
                          MenuItemRadio[i][j].tagNo = i * MenusNames.length + j;
                          MenuItemRadio[i][j].setTextAlign(GAlign.LEFT | GAlign.TOP);
                          MenuItemRadioGroups[i].addOption(j, MenuItemRadio[i][j]);
                        //Disable button
                          MenuItemRadio[i][j].setVisible(false);
                          MenuItemRadio[i][j].setEnabled(false);
                      }
                    //Checkbox
                      if(MenuItemName[i][j].charAt(0) == '#'){
                        //Create checkbox
                          MenuItemCheck[i][j] = new GCheckbox(this, MenuItemNameTemp, xTempItem, yTempItem, 127);
                          MenuItemCheck[i][j].tag = MenuItemNameTemp;
                          MenuItemCheck[i][j].tagNo = i * MenusNames.length + j;
                          MenuItemCheck[i][j].setTextAlign(GAlign.LEFT | GAlign.TOP);
                        //Disable checkbox
                          MenuItemCheck[i][j].setVisible(false);
                          MenuItemCheck[i][j].setEnabled(false);
                      }
                    yTempItem = yTempItem + 21;
                }
                xTempItem = xTempItem + MenusWidths[i] + 1;
        }
        
        GUIMenuItemSetup();
}

void GUIloop(String renderer){
  //Both
    fill(198,198,198);
    stroke(99,99,99);
    rect(0,0,width,21);
  //P3D Only
    if(renderer == P3D){
      
    }
  //OPENGL Only
    else{
      
    }
  //Both
}

void replaceGUI(String[] newMenuBar, GButton[] newMenus, String[][] newElements, GButton[][] newButtons, GOptionGroup[] newRadioGroups, GOption[][] newRadios, GCheckbox[][] newChecks){
  //Dispose Menu Bar
  for(int i=0; i<MenuItemName.length; i++){
    Menus[i].dispose();
  }
  //Disposes all elements of every dropdown menu and replaces them with new Elements
  //Dispose all items
  for(int i=0; i<MenuItemName.length; i++){
    for(int j=0; j<MenuItemName[i].length; j++){
      if(MenuItemName[i][j].charAt(0) == '!'){
        MenuItemButtons[i][j].dispose();
      }
      if(MenuItemName[i][j].charAt(0) == '@'){
        MenuItemRadio[i][j].dispose();
      }
      if(MenuItemName[i][j].charAt(0) == '#'){
        MenuItemCheck[i][j].dispose();
      }
    }
  }
  //Menu Bar
    MenusNames = newMenuBar;
    Menus = newMenus;
  //Menu Item Names
    MenuItemName = newElements;
  //Buttons
    MenuItemButtons = newButtons;
  //Radio Buttons
    MenuItemRadioGroups = newRadioGroups;
    MenuItemRadio = newRadios;
  //Checkboxes
    MenuItemCheck = newChecks;
  //Component Creation
      //X offset for Menu Bar
        int xTemp = 1;
      //X offset for menu Items
        int xTempItem = 1;
        MenusWidths = new int[MenusNames.length];
        for(int i=0; i<Menus.length; i++){
          //Menu Bar
          //tagNo is the index -1 to prevent interference with Menu Items
          //First menu tagNo is -1
            MenusWidths[i] = MenusNames[i].length() * 7 + 12;
            Menus[i] = new GButton(this, MenusNames[i], xTemp, 1, MenusWidths[i], 20);
            Menus[i].tagNo = i * -1 -1;
            Menus[i].setTextAlign(GAlign.LEFT | GAlign.TOP);
          //X offset for menu items 
            xTemp = xTemp + MenusWidths[i] + 1;
        }
      //Menu Items
        for(int i=0; i<Menus.length; i++){
          //Component Creation
            //Option Groups
              MenuItemRadioGroups[i] = new GOptionGroup(this);
            //Menu Items
              //Y offset for Menu Items
                int yTempItem = 22;
                for(int j=0; j<MenuItemName[i].length; j++){
                  String MenuItemNameTemp = MenuItemName[i][j].substring(1);
                  //Component tagNo X = floor(button.tagNo / MenusNames.length)
                  //Component tagNo Y = button.tagNo % MenusNames.length
                  //First element of first menu is 0,0
                    //Button
                      if(MenuItemName[i][j].charAt(0) == '!'){
                        //Create button
                          MenuItemButtons[i][j] = new GButton(this, MenuItemNameTemp, xTempItem, yTempItem, 127, 20);
                          MenuItemButtons[i][j].tag = MenuItemNameTemp;
                          MenuItemButtons[i][j].tagNo = i * MenusNames.length + j;
                          MenuItemButtons[i][j].setTextAlign(GAlign.LEFT | GAlign.TOP);
                        //Disable button
                          MenuItemButtons[i][j].setVisible(false);
                          MenuItemButtons[i][j].setEnabled(false);
                      }
                    //Radio Button
                      if(MenuItemName[i][j].charAt(0) == '@'){
                        //Create radio button
                          MenuItemRadio[i][j] = new GOption(this, MenuItemNameTemp, xTempItem, yTempItem, 127);
                          MenuItemRadio[i][j].tag = MenuItemNameTemp;
                          MenuItemRadio[i][j].tagNo = i * MenusNames.length + j;
                          MenuItemRadio[i][j].setTextAlign(GAlign.LEFT | GAlign.TOP);
                          MenuItemRadioGroups[i].addOption(j, MenuItemRadio[i][j]);
                        //Disable button
                          MenuItemRadio[i][j].setVisible(false);
                          MenuItemRadio[i][j].setEnabled(false);
                      }
                    //Checkbox
                      if(MenuItemName[i][j].charAt(0) == '#'){
                        //Create checkbox
                          MenuItemCheck[i][j] = new GCheckbox(this, MenuItemNameTemp, xTempItem, yTempItem, 127);
                          MenuItemCheck[i][j].tag = MenuItemNameTemp;
                          MenuItemCheck[i][j].tagNo = i * MenusNames.length + j;
                          MenuItemCheck[i][j].setTextAlign(GAlign.LEFT | GAlign.TOP);
                        //Disable checkbox
                          MenuItemCheck[i][j].setVisible(false);
                          MenuItemCheck[i][j].setEnabled(false);
                      }
                    yTempItem = yTempItem + 21;
                }
                xTempItem = xTempItem + MenusWidths[i] + 1;
        }
      //Default settings on startup
        //Show
          for(int i=0; i<MenuItemCheck[1].length; i++){
            MenuItemCheck[1][i].setSelected(true);
            //MenuItemCheck[2][i].setSelected(false);
          }
        //Lights
          MenuItemCheck[4][2].setSelected(true);
}

void GUIMenuItemSetup(){
  PonyBase.specialScan(Minecraft);
  //Check for pony skin
    if(PonyBase.race != 0){
      //Change to Pony GUI
        replaceGUI(PonyBase.MenuBar, PonyBase.Menus, PonyBase.GUIMenuItemNames, PonyBase.GUIButtons, PonyBase.GUIRadioGroups, PonyBase.GUIRadios, PonyBase.GUIChecks);
      //Set Pose
        MenuItemRadioGroups[3].setSelected(0);
      //Set race
        MenuItemRadioGroups[5].setSelected(PonyBase.race-1);
      //Set tailLength
        MenuItemRadioGroups[6].setSelected(PonyBase.tailLength);
      //Set Gender
        if(PonyBase.male == 1){
          MenuItemCheck[5][5].setSelected(true);
        }
      //Set pony size
        switch(PonyBase.ponySize){
          case 0:
            MenuItemRadioGroups[7].setSelected(0);
            break;
          case 1:
            MenuItemRadioGroups[7].setSelected(1);
            break;
          case 2:
            MenuItemRadioGroups[7].setSelected(2);
            break;
          case 3:
            MenuItemRadioGroups[7].setSelected(3);
            break;
          default:
            break;
        }
    }
    else{
      //Change to Human GUI
        replaceGUI(Human.MenuBar, Human.Menus, Human.GUIMenuItemNames, Human.GUIButtons, Human.GUIRadioGroups, Human.GUIRadios, Human.GUIChecks);
        MenuItemRadioGroups[5].setSelected(4);
    }
}
