//Use screenX and screenY for direct model painting
//Add check for .png files to MinecraftSkin class
//Implement GUI

//Objects
  MinecraftSkin Minecraft = new MinecraftSkin();
  MCPonyBase PonyBase = new MCPonyBase();
  
  MCPonyNormal NormalPony = new MCPonyNormal(Minecraft, PonyBase);
  MCPonyFoal SmallPony = new MCPonyFoal(Minecraft, PonyBase);
  MCPonyLarge LargePony = new MCPonyLarge(Minecraft, PonyBase);
  MCPonyAlicorn PrincessPony = new MCPonyAlicorn(Minecraft, PonyBase);
  MCHuman Human = new MCHuman(Minecraft);
//Model direction variables
  int directionY = 60;
  int directionX = 210;

//Libraries
/*
http://www.lagers.org.uk/g4p/
http://www.lagers.org.uk/g4p/distribution/web/reference/guicomponents/GComponent.html
/*/
//GUI library
import guicomponents.*;
//OPENGL Can be removed if using P3D to save space
import processing.opengl.*;
//Set to renderer
String renderer = P3D;
void setup(){
  size(800,600,renderer);
  GUIsetup(renderer);
}

void draw(){
  background(255, 255, 255);
  //Draw preview
    //2D
//      noStroke();
//      for(int i=0; i<64; i++){
//        for(int j=0; j<32; j++){
//          fill(128, 128, 128);
//          rect(16*i+20, 16*j+height-276, 16, 16);
//          fill(red(Minecraft.loadedImage.pixels[i+j*64]),green(Minecraft.loadedImage.pixels[i+j*64]),blue(Minecraft.loadedImage.pixels[i+j*64]),alpha(Minecraft.loadedImage.pixels[i+j*64]));
//          rect(16*i+20, 16*j+height-276, 16, 16);
//        }
//      }
    //3D
    //Rotate with mouse movement
      if(leftDown){
        directionX = directionX + mouseDX();
        directionY = directionY + mouseDY();
      }
    //println(mouseX+","+mouseY);
    pushMatrix();
      noSmooth();
      if(MenuItemCheck[4][1].isSelected()){
        smooth();
      }
      noLights();
      if(MenuItemCheck[4][2].isSelected()){
        lights();
      }
      translate(width/2, height/2, 0);
      rotateX(radians(directionY));
      rotateZ(radians(directionX));
        noStroke();
        if(!MenuItemRadio[5][4].isSelected()){
          if(MenuItemRadio[7][0].isSelected()){
            NormalPony.drawPony();
          }
          if(MenuItemRadio[7][1].isSelected()){
            SmallPony.drawPony();
          }
          if(MenuItemRadio[7][2].isSelected()){
            LargePony.drawPony();
          }
          if(MenuItemRadio[7][3].isSelected()){
            PrincessPony.drawPony();
          }
        }
        else{
          Human.drawHuman();
        }
    popMatrix();
    smooth();
    noLights();
    strokeWeight(1);
  GUIloop(renderer);
}
